"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@oclif/core");
const command_base_1 = __importDefault(require("./../command-base"));
class Generate extends command_base_1.default {
    static args = {
        name: core_1.Args.string({ description: 'directory name of new project', required: true }),
    };
    static description = `generate a new CLI
This will clone the template repo 'oclif/hello-world' and update package properties`;
    static flags = {
        defaults: core_1.Flags.boolean({ hidden: true }),
    };
    async run() {
        const { args, flags } = await this.parse(Generate);
        await super.generate('cli', {
            defaults: flags.defaults,
            force: true,
            name: args.name,
        });
    }
}
exports.default = Generate;
