"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@oclif/core");
const command_base_1 = __importDefault(require("./../../command-base"));
class GenerateCommand extends command_base_1.default {
    static args = {
        name: core_1.Args.string({ description: 'name of command', required: true }),
    };
    static description = 'add a command to an existing CLI or plugin';
    static flags = {
        force: core_1.Flags.boolean({ description: 'overwrite existing files' }),
    };
    async run() {
        const { args, flags } = await this.parse(GenerateCommand);
        await super.generate('command', {
            force: flags.force,
            name: args.name,
        });
    }
}
exports.default = GenerateCommand;
