"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@oclif/core");
const fs = __importStar(require("fs-extra"));
const node_path_1 = require("node:path");
const command_base_1 = __importDefault(require("./../../command-base"));
class GenerateHook extends command_base_1.default {
    static args = {
        name: core_1.Args.string({ description: 'name of hook (snake_case)', required: true }),
    };
    static description = 'add a hook to an existing CLI or plugin';
    static flags = {
        event: core_1.Flags.string({ default: 'init', description: 'event to run hook on' }),
        force: core_1.Flags.boolean({ description: 'overwrite existing files' }),
    };
    async run() {
        const { args, flags } = await this.parse(GenerateHook);
        const tsConfigPath = (0, node_path_1.resolve)(process.cwd(), 'tsconfig.json');
        const tsConfig = await fs.readJSON(tsConfigPath).catch(() => ({}));
        await super.generate('hook', {
            event: flags.event,
            force: flags.force,
            name: args.name,
            outDir: tsConfig.compilerOptions?.outDir ?? 'dist',
        });
    }
}
exports.default = GenerateHook;
