import { Interfaces } from '@oclif/core';
import Generator from 'yeoman-generator';
export default class CLI extends Generator {
    answers: {
        author: string;
        bin: string;
        ci: {
            appveyor: boolean;
            circleci: boolean;
            travisci: boolean;
        };
        description: string;
        eslint: boolean;
        files: string;
        github: {
            repo: string;
            user: string;
        };
        license: string;
        mocha: boolean;
        name: string;
        pkg: string;
        typescript: boolean;
        version: string;
    };
    githubUser: string | undefined;
    name: string;
    options: {
        defaults?: boolean;
        force: boolean;
        yarn: boolean;
    };
    pjson: Interfaces.PJSON.Plugin;
    repository?: string;
    yarn: boolean;
    constructor(args: string | string[], opts: Generator.GeneratorOptions);
    end(): void;
    prompting(): Promise<void>;
    writing(): Promise<void>;
    private _gitignore;
}
